#pragma once

#include <stdbool.h>
#include <stdint.h>

struct gcpointer_t
{
	intptr_t ptr;
	struct gcpointer_t* next;
};

void gcpointer_ctor(gcpointer_t* this);
void gcpointer_ctor(gcpointer_t* this, void* address);
void gcpointer_ctor(gcpointer_t* this, gcpointer_t* other);
void gcpointer_dtor(gcpointer_t* this);
gcpointer_t* gcpointer_assign(gcpointer_t* this, gcpointer_t* rhs);

//Logical operators
bool gcpointer_equal(gcpointer_t* this, gcpointer_t* rhs);
bool gcpointer_not_equal(gcpointer_t* this, gcpointer_t* rhs);
bool gcpointer_null(gcpointer_t* this);

forall(otype T)
struct gcpointer
{
	gcpointer_t internal;
};

forall(otype T)
static inline void ctor(gcpointer(T)* this)
{
	gcpointer_ctor(&this->internal);
}

// forall(otype T)
// static inline void ctor(gcpointer(T)* this, int null)
// {
// 	gcpointer_ctor(&this->internal, NULL);
// }

forall(otype T)
static inline void ctor(gcpointer(T)* this, void* address)
{
	gcpointer_ctor(&this->internal, address);
}

forall(otype T)
static inline void ctor(gcpointer(T)* this, gcpointer(T)* other)
{
	gcpointer_ctor(&this->internal, other);
}

forall(otype T)
static inline void dtor(gcpointer(T)* this)
{
	gcpointer_dtor(&this->internal);
}

forall(otype T)
static inline gcpointer(T)* ?=?(gcpointer(T)* this, gcpointer(T)* rhs)
{
	gcpointer_assign(&this->internal, &rhs->internal);
	return this;
}

forall(otype T)
static inline T *?(gcpointer(T) this)
{
	return *(T*)this.internal.ptr;
}

//Logical operators
forall(otype T)
static inline int ?!=?(gcpointer(T) this, gcpointer(T) rhs)
{
	return this.internal.ptr != rhs.internal.ptr;
}

forall(otype T)
static inline int ?==?(gcpointer(T) this, gcpointer(T) rhs)
{
	return !(this == rhs);
}

forall(otype T)
extern struct gcpointer(T) 0;
